#ifndef _OME_IO_EVENTS_H
//! \cond
#define _OME_IO_EVENTS_H "$Id: OMEioEvents.h 422 2020-07-14 17:18:19Z fargos $"
//! \endcond

#include <OMEevent.h>

/** \addtogroup OMEevent
 * @{
 */

/*!
\brief I/O-specific event.
*/
// OMEprocessEvent also inherits from OMEioEvent
class OMEioEvent : public OMEevent {
public:
	static void selectIOevent(OMEioEvent *event);

	enum OMEfileType { file, socket, pipe, process, genericEvent };
	enum OMEselectMode { selectRead, selectWrite, eventObj, notUsed };

	OMEioEvent	    *nextEvent;
	int		        tableIndex;
	OMEfileType     fileType;
	OMEselectMode	selectMode;

	OMEioEvent(OMEfileType t, OMEselectMode m, uint64_t handle,
		OMEeventCallbackFP func, OMEthread *thread = nullptr,
		void *extra = nullptr);

	~OMEioEvent() {}

	void deselectIOevent();
}; // end class OMEioEvent

int OMEwaitForIO(uint_fast32_t delay = 0);

int OMEremoveSelectEvent(uint64_t handle, OMEioEvent::OMEselectMode m);

extern "C" void OMErequestShutdown();

#ifdef _WIN32
void OMEcreateShutdownEvent();

extern "C" OMEwin32MessageLoopFP	OMEwin32MessageLoopPtr;
#endif

/** @}
 */
#endif
/* vim: set expandtab shiftwidth=4 tabstop=4: */
