#ifndef _OME_ROUTE_ENTRY_H
//! \cond
#define _OME_ROUTE_ENTRY_H "$Id: OMErouteEntry.h 453 2020-07-23 20:20:44Z geoff $"
//! \endcond

// inter-process routing info

/*! \brief Represents route to a remote FARGOS/VISTA
 * Object Management Environment instance or attached application.
 */
class OMErouteEntry {
public:
	OMEentityID	destID;
	OMEoid		*remoteRoot;
	OMEoid		*forwardingObject;
	uint32_t	distance;

	OMErouteEntry(const OMEentityID &id, const OMEoid &rmtRoot, const OMEoid &fwdObj, uint32_t dist) {
		destID = id;
		remoteRoot = new OMEoid(rmtRoot);
		forwardingObject = new OMEoid(fwdObj);
		distance = dist;
	}

	~OMErouteEntry() {
		delete remoteRoot;
		delete forwardingObject;
	}
}; // end class OMErouteEntry

/*! \brief Lookup the gateway object to be used to send a messsage to
 * a particular object identifier.
 */
const OMEoid *OMEfindGatewayToDestination(const OMEoid *);

//! \brief Clear the entire routing table.
void OMEclearRoutingTable();

#endif
/* vim: set expandtab shiftwidth=4 tabstop=4: */
